#include "PrettyPrintSerializer.hpp"

#include <exception>
#include <sstream>
#include <iostream>

//////////////////////////////////////////////////////////////////////////////////////
// TPrettyPrintSerializer : Implmentation
//////////////////////////////////////////////////////////////////////////////////////

template<class Elem>
PSF::TPrettyPrintSerializer<Elem>::TPrettyPrintSerializer( std::basic_ostream<Elem>& i_ostream, int i_nNesting) :
	m_ostream( i_ostream),
	m_nNesting( i_nNesting)
{
}

template<class Elem>
PSF::TPrettyPrintSerializer<Elem>::~TPrettyPrintSerializer()
{
}


template<class Elem>
void PSF::TPrettyPrintSerializer<Elem>::Serialize( const int& i_in)
{
	m_ostream << i_in << m_ostream.widen(' ');
}

template<class Elem>
void PSF::TPrettyPrintSerializer<Elem>::Serialize( const unsigned int& i_in)
{
	m_ostream << i_in << m_ostream.widen(' ');
}

template<class Elem>
void PSF::TPrettyPrintSerializer<Elem>::Serialize( const bool& i_in)
{
	m_ostream << std::boolalpha << i_in << m_ostream.widen(' ');
}

template<class Elem>
void PSF::TPrettyPrintSerializer<Elem>::Serialize( const char& i_in)
{
	m_ostream << i_in << m_ostream.widen(' ');
}

template<class Elem>
void PSF::TPrettyPrintSerializer<Elem>::Serialize( const unsigned char& i_in)
{
	m_ostream << i_in << m_ostream.widen(' ');
}

template<class Elem>
void PSF::TPrettyPrintSerializer<Elem>::Serialize( const short& i_in)
{
	m_ostream << i_in << m_ostream.widen(' ');
}

template<class Elem>
void PSF::TPrettyPrintSerializer<Elem>::Serialize( const unsigned short& i_in)
{
	m_ostream << i_in << m_ostream.widen(' ');
}

template<class Elem>
void PSF::TPrettyPrintSerializer<Elem>::Serialize( const long& i_in)
{
	m_ostream << i_in << m_ostream.widen(' ');
}

template<class Elem>
void PSF::TPrettyPrintSerializer<Elem>::Serialize( const unsigned long& i_in)
{
	m_ostream << i_in << m_ostream.widen(' ');
}

template<class Elem>
void PSF::TPrettyPrintSerializer<Elem>::Serialize( const float& i_in)
{
	m_ostream << i_in << m_ostream.widen(' ');
}

template<class Elem>
void PSF::TPrettyPrintSerializer<Elem>::Serialize( const double& i_in)
{
	m_ostream << i_in << m_ostream.widen(' ');
}

template<class Elem>
Elem Convert( const wchar_t& i_in)
{
	// should use the streams current locale to do this conversion
	return (Elem)i_in;
}

template<>
wchar_t Convert<wchar_t>( const wchar_t& i_in)
{
	return i_in;
}

template<class Elem>
void PSF::TPrettyPrintSerializer<Elem>::Serialize( const wchar_t& i_in)
{
	m_ostream << Convert<Elem>(i_in);
}

template<class Elem>
std::auto_ptr<PSF::ISerializer> PSF::TPrettyPrintSerializer<Elem>::SerializeCompound( const std::wstring& i_wstrName, 
																					 const Loki::TypeInfo& i_type)
{
	Elem space = m_ostream.widen(' ');
	std::basic_string<Elem> strNesting( m_nNesting*4, space);
	std::basic_string<Elem> strName;
	std::wstring::const_iterator iterName;
	std::wstringstream wstream;
	for ( iterName = i_wstrName.begin(); iterName != i_wstrName.end(); ++iterName)
	{
		char c = wstream.narrow( *iterName, '?');
		strName.push_back( m_ostream.widen( c));
	}
	m_ostream << std::endl << strNesting << strName << space << m_ostream.widen(':') << space;
	return std::auto_ptr<ISerializer>( new TPrettyPrintSerializer( m_ostream, m_nNesting+1));
}

template<class Elem>
std::auto_ptr<PSF::ISerializer> PSF::TPrettyPrintSerializer<Elem>::SerializeRange( const std::wstring& i_wstrName, 
																				  const Loki::TypeInfo& i_type)
{
	return SerializeCompound( i_wstrName, i_type);
}


